/* alle Rechte by achim seeger unter GPL
   myroboter@web.de, wnsche viel Spass damit */

#define F_CPU 16000000				// CPU clock in Hz
#include <stdint.h>
#include <stdbool.h>
#include <avr/pgmspace.h>
#include "HT16K33.h"
#include "i2cmaster.h"
#include "util/delay.h"

int bild1 [8] = {0x3c, 0x42, 0xa5, 0x81, 0xa5, 0x99, 0x42, 0x3c};	// Bild 1
int bild2 [8] = {0x3c, 0x42, 0x95, 0xa1, 0xa1, 0x95, 0x42, 0x3c};	// Bild 2
	
void HT16K33_Init(void)						// HT16K33 initieiren
  {  
	HT16K33_SetOscillator(true);			// schaltet Oszillator ein 
	HT16K33_Blinken(HT16K33_BLINK_OFF);		// SETZ 0-AUS ODER 1-EIN
	HT16K33_SetBrightness(15);				// setzt Helligkeit max 15 (0..15)
  }
 
void HT16K33_SetOscillator(bool osc_on)		// schaltet Oszi ein
  {
	i2c_start(HT16K33_modul1_addr<<1);
	if (osc_on)
	  {
	    i2c_write(HT16K33_CMD_OSCILLATOR | 1);	// oscillator ein
	  }	  
	else
	  {
	    i2c_write(HT16K33_CMD_OSCILLATOR);		// oscillator aus
	  }	  
	i2c_stop();								// Bus stop
  }

void HT16K33_Blinken(uint8_t b)				// schaltet Blinken
  {
	i2c_start(HT16K33_modul1_addr<<1);
	if (b > 3) b = 0;						// Sicherheitsabfrage
	i2c_write(HT16K33_CMD_BLINK | HT16K33_BLINK_DISPLAYON | (b << 1));
	i2c_stop();								// Bus stop
  }

void HT16K33_SetBrightness(uint8_t b)		// schaltet Helligkeit
  {
	if (b > 15) b = 15;						// Sicherheitsabfrage
	i2c_start(HT16K33_modul1_addr<<1);		// Bus start, Angabe Adresse
	i2c_write(HT16K33_CMD_BRIGHTNESS | b);	// schreibt Wert
	i2c_stop();								// Bus stop
  }
  
void HT16K33_WriteBild1(uint8_t start)		// schreibt bild1
  {  
	int8_t nr = 0;							// array nr auf 0
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.   
	  {
		 i2c_start(HT16K33_modul1_addr<<1);	// schreibt modul 1
		 i2c_write(i);						// angabe Zeile  
		 i2c_write(bild1[nr]);				// anzeige array
		 nr = nr +1;						// array nr um 1 erhht
		 i2c_stop();						// Bus stop
	  }
  }
  
void HT16K33_WriteBild2(uint8_t start)		// schreibt bild2
  {
	  int8_t nr = 0;						// array nr auf 0
	  for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {  
		 i2c_start(HT16K33_modul1_addr<<1); // schreibt modul 1
		 i2c_write(i);						// angabe Zeile
		 i2c_write(bild2[nr]);				// anzeige array
		 nr = nr +1;						// array nr um 1 erhht
		 i2c_stop();						// Bus stop
	  }
  }
 
void HT16K33_WriteDisplay(uint8_t start)	// fllt komplette Matrix
  {
    for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {  
		 i2c_start(HT16K33_modul1_addr<<1); // schreibt modul 1
		 i2c_write(i);						// angabe Zeile
		 i2c_write(0xbb);					// angabe LED-alle ein
		 i2c_stop();						// Bus stop
	  }
  }

void HT16K33_ClearDisplay(uint8_t start)	// lscht komplette Matrix
  {
	for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.	
      {
		i2c_start(HT16K33_modul1_addr<<1);	// schreibt modul 1
		i2c_write(i);						// angabe Zeile
		i2c_write(0x00);					// angabe LED-alle aus
		i2c_stop();							// Bus stop
	  }
  }
  
void HT16K33_FillDisplay(uint8_t start)		// fllt komplette Matrix
  {
    for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	  {
		 i2c_start(HT16K33_modul1_addr<<1); // schreibt modul 1
		 i2c_write(i);						// angabe Zeile
		 i2c_write(0xff);					// angabe LED-alle ein
		 i2c_stop();						// Bus stop
	  }
  }
  
void HT16K33_WriteBild1Zeit(uint8_t start)// schreibt bild1
  {  
	 int8_t nr = 0;							// array nr auf 0
	 for (uint8_t i=start; i<16; i+=2)		// Auswahl der Zeile jede 2.
	   {
		 i2c_start(HT16K33_modul1_addr<<1);	// schreibt modul 1
		 i2c_write(i);						// angabe Zeile
		 i2c_write(bild1[nr]);				// anzeige array
		 nr = nr +1;						// array nr um 1 erhht
		 _delay_ms(200);
		 i2c_stop();						// Bus stop
	   }
  }
  